<!DOCTYPE html>
<html>
<title> Bootstrap template- Pizza 365 project</title>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<!-- font -->
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

<!-- Bootstrap -->
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<link rel="stylesheet" href="css/style">
<style>
  
</style>
<body onload="onPageLoading()">

  <!-- Menu -->
  <div class="container-fluid bg-light">
    <div class="row">
      <div class="col-sm-12">
        <nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light">
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
            aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav nav-fill w-100">
              <li class="nav-item active">
                <a class="nav-link" href="#">Home</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#plans">Plans</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#about">About</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" id="order-detail" onclick="onBtnOrderDetailClick()">Order Detail</a>
              </li>
            </ul>
          </div>
        </nav>
      </div>
    </div>
  </div>

  <!-- Content -->
  <div class="container" style="padding: 120px 0 50px 0;">
    <div class="row">
      <div class="col-sm-12">
        <div class="row">
          <!-- Title row home -->
          <div class="col-sm-12">
            <h1><b>Pizza 365</b></h1>
            <p style="font-style: italic">Truly italian !</p>
          </div>

          <!-- Slide row home -->
          <div class="col-sm-12">
            <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
              <ol class="carousel-indicators">
                <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="2"></li>
              </ol>
              <div class="carousel-inner">
                <div class="carousel-item active">
                  <img class="d-block w-100" src="images/mon_y_1.jpg" alt="First slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_2.jpg" alt="Second slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_3.jpg" alt="Third slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_4.jpg" alt="Fourth slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_5.jpg" alt="Fifth slide">
                </div>
              </div>
              <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
              </a>
              <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
              </a>
            </div>
          </div>

          <!-- Title what we offer -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Tại sao lại Pizza 365</b></h2>
          </div>

          <!-- Content what we offer -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-3 p-4 bg-warning border border-warning text-white">
                <h3 class="p-2">Món ăn</h3>
                <p class="p-2">Món ăn được chế biến từ nguồn nguyên liệu oganic, và được chế biến bởi các đầu bếp nổi tiếng, mang lại hương vị tươi ngon nhất cho khách hàng.</p>
              </div>
              <div class="col-sm-3 p-4 bg-white border border-warning text-warning">
                <h3 class="p-2">Không gian</h3>
                <p class="p-2">Đến với Pizza 365 quý khách sẽ được tận hưởng các món ăn với không gian ấm áp và sang trọng, đem lại sự thoải mái cho khách hàng.</p>
              </div>
              <div class="col-sm-3 p-4 bg-warning border border-warning text-white">
                <h3 class="p-2">Dịch vụ</h3>
                <p class="p-2">Đội ngũ nhân viên chuyên nghiệp, phục vụ tận tâm, nhiệt tình hỗ trợ khách hàng và lắng nghe những ý kiến từ khách hàng, để đem lại sự phục vụ tốt nhất.</p>
              </div>
              <div class="col-sm-3 p-4 bg-white border border-warning text-warning">
                <h3 class="p-2">Ưu đãi hấp dẫn</h3>
                <p class="p-2">Có nhiều chương trình giảm giá hấp dẫn vào mỗi cuối tuần. Ngoài ra còn được giảm giá các ngày cho những khách hàng mua với hóa đơn trên 200VND .</p>
              </div>
            </div>
          </div>
        </div>

        <div id="plans" class="row">
          <!-- Title what we offer -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-1 border-bottom">Menu Combo Pizza 365</b></h2>
            <p><span class="p-2">Hãy chọn cỡ pizza phù hợp với bạn!</span></p>
          </div>
          <!-- Content what we offer -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-dark text-white text-center">
                    <h3>Small</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item"><b>20cm</b> Đường kính</li>
                      <li class="list-group-item"><b>1</b> Sườn nướng</li>
                      <li class="list-group-item"><b>200g</b> Salad</li>
                      <li class="list-group-item"><b>2</b> Nước ngọt</li>
                      <li class="list-group-item">
                        <h1><b>VNĐ 150.000</b></h1>
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-combo-small" class="btn btn-success" onclick="onBtnMenuSizeSmallClick()">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-secondary text-white text-center">
                    <h3>Medium</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item"><b>25cm</b> Đường kính</li>
                      <li class="list-group-item"><b>4</b> Sườn nướng</li>
                      <li class="list-group-item"><b>300g</b> Salad</li>
                      <li class="list-group-item"><b>3</b> Nước ngọt</li>
                      <li class="list-group-item">
                        <h1><b>VNĐ 200.000</b></h1>
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-combo-medium" class="btn btn-success" onclick="onBtnMenuSizeMediumClick()">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-dark text-white text-center">
                    <h3>Large</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item"><b>30cm</b> Đường kính</li>
                        <li class="list-group-item"><b>8</b> Sườn nướng</li>
                        <li class="list-group-item"><b>500g</b> Salad</li>
                        <li class="list-group-item"><b>4</b> Nước ngọt</li>
                        <li class="list-group-item">
                          <h1><b>VNĐ 250.000</b></h1>
                        </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-combo-large" class="btn btn-success" onclick="onBtnMenuSizeLargeClick()">Chọn</button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div id="about" class="row">
          <!-- Title Who We Are -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Chọn loại Pizza</b></h2>
          </div>

          <!-- Content Who We Are -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <img src="images/pizza_type_1.jpg" class="card-img-top">
                  <div class="card-body">
                    <h3>Pizza Hawai</h3>
                    <p>Nguyên liệu: tôm, thịt, rong biển và sốt cà chua nhập từ Hawai, tạo hương vị mới lạ.</p>
                    <p><button id="btn-pizza-hawai" class="btn btn-success w-100" onclick="onBtnPizzaHawaiClick()">Chọn</button></p>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <img src="images/pizza_type_2.jpg" class="card-img-top">
                  <div class="card-body">
                    <h3>Pizza Hải sản</h3>
                    <p>Nguyên liệu: các loại hải sản tôm, mực ốc kết hợp với nước sốt chua ngọt vị đậm đà.</p>
                    <p><button id="btn-pizza-hai-san" class="btn btn-success w-100" onclick="onBtnPizzaHaiSanClick()">Chọn</button></p>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <img src="images/pizza_type_3.jpg" class="card-img-top">
                  <div class="card-body">
                    <h3>Pizza thịt hun khói</h3>
                    <p>Nguyên liệu: thịt dăm bông, lạp xưởng và thịt hun khói kết hợp cùng với sốt cà chua.</p>
                    <p><button id="btn-pizza-thit-hun-khoi" class="btn btn-success w-100" onclick="onBtnPizzaThitHunKhoiClick()">Chọn</button></p>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
         <!--Chọn đồ uống-->
         <div class="text-center">
          <label><h4><b>Hãy chọn đồ uống bạn yêu thích</b></h4></label>
        </div>
        <div>
          <select id="select-drink" class="form-control">
            <option value="0" type="text">Chọn đồ uống</option>
          </select>
        </div>

        <div id="contact" class="row">
          <!-- Title Contact Us -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Thông tin đơn hàng</b></h2>
          </div>

         
          <!-- Content Contact Us -->
          <div class="col-sm-12 p-2 jumbotron">
            <div class="row">
              <div class="col-sm-12">
                <div class="form-group">
                  <label for="fullname">Họ và tên</label>
                  <input type="text" class="form-control" id="inp-fullname" placeholder="Họ và tên">
                </div>
                <div class="form-group">
                  <label for="email">Email</label>
                  <input type="text" class="form-control" id="inp-email" placeholder="Email">
                </div>
                <div class="form-group">
                  <label for="dien-thoai">Điện thoại</label>
                  <input type="text" class="form-control" id="inp-dien-thoai" placeholder="Điện thoại">
                </div>
                <div class="form-group">
                  <label for="dia-chi">Địa chỉ</label>
                  <input type="text" class="form-control" id="inp-dia-chi" placeholder="Địa chỉ">
                </div>
                <div class="form-group">
                  <label for="message">Lời nhắn</label>
                  <input type="text" class="form-control" id="inp-message" placeholder="Lời nhắn">
                </div>
                <div class="form-group">
                  <label for="voucher">Mã giảm giá (Voucher ID)</label>
                  <input type="text" class="form-control" id="inp-voucher" placeholder="Mã giảm giá" />
                </div>
                <button type="button" class="btn btn-success w-100" onclick="onBtnKiemTraDonClick()">Kiểm tra đơn</button>
              </div>
            </div>
          </div>
          <!-- vùng hiển thị thông tin đơn hàng(order) -->
          <div id="div-container-order" class="container p-2 jumbotron picture" style="display: none">
            <div class="row">
              <div class="col-sm-3">
                <div id="div-order-infor" class="text-dark p-3">...</div>
                <p class="text-dark">
                  ...........................................
                </p>
                <div id="div-order-menu" class="text-dark p-3">...</div>
                <p class="text-dark">
                  ...........................................
                </p>
                <div id="div-order-type" class="text-dark p-3">...</div>
              </div>
              <div class="col-sm-9 text-center w-500 p-4">
                <img src="images/hinh-0.png">
              </div>
            </div>
            <div class="row p-2">
              <button type="button" class="btn btn-success w-100" onclick="onBtnGuiDonClick()">Gửi đơn</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
   <!-- vùng hiển thị lời cảm ơn và hiện mã đơn hàng -->
   <div id="div-container-orderid" class="container bg-orderid " style="display: block; width: 700px;">
    <h3 class="text-center text-com-on font-weight-bold">Cảm ơn bạn đã đặt hàng tại Pizza 365 !!!</h3>
    <br>
    <h5 class="ma_don">Mã đơn hàng của bạn là: </h5>

    <div id="ma-don-hang" class="col-sm-12">

        <div class="row">
            <div class="col-sm-4"></div>
            <div class="col-sm-4">
                <input type="text" class="form-control col-sm8 text-center" id="inp-orderid" placeholder="Mã đơn hàng">
            </div>
            <div class="col-sm-4"></div>
        </div>
    </div>

</div>


  <!-- Footer -->
  <div class="container-fluid bg-light p-5">
    <div class="row text-center">
      <div class="col-sm-12">
        <h4 class="m-2">Footer</h4>
        <a href="#" class="btn btn-dark m-3"><i class="fa fa-arrow-up"></i>To the top</a>
        <div class="m-2">
          <i class="fa fa-facebook-official w3-hover-opacity"></i>
          <i class="fa fa-instagram w3-hover-opacity"></i>
          <i class="fa fa-snapchat w3-hover-opacity"></i>
          <i class="fa fa-pinterest-p w3-hover-opacity"></i>
          <i class="fa fa-twitter w3-hover-opacity"></i>
          <i class="fa fa-linkedin w3-hover-opacity"></i>
        </div>
      </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 tao thanh cong


    // bạn có thê dùng để lưu trữ combo được chọn, mỗi khi khách chọn bạn lại đổi giá trị properties của nó
    var gSelectedMenuStructure = {
      menuName: "...",    // S, M, L
      duongKinhCM: 0,
      suongNuong: 0,
      saladGr: 0,
      drink: 0,
      priceVND: 0
    };
    var gSelectedMenuStructure = getOrder("", 0, 0, "", 0, 0);   //đầu tiên gán cho nó giá trị mặc định
    // bạn có thể dùng để lưu loại pizza đươc chọn, mỗi khi khách chọn, bạn lại đổi giá trị cho nó
    var gSelectedPizzaType = "..."

   // dùng để lưu thông tin khách đặt hàng
    var gUser = {
      comboDuocChon: "",
      loaiPizzaDuocChon: "",
      loaiDoUongDuocChon: "",
      hoTen: "",
      email: "",
      soDienThoai: "",
      diaChi: "",
      loiNhan: "",
      maVoucher: "",
    };

    // biến toàn cục giá tiền sau khi đc giãm
    var gGiamGia = {
            maVoucher: "",
            phanTramGiamGia: 0,
            price: 0
    };
     // Biến toàn cục đơn hàng
     const gDonHangObject = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: ""
    };
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // Hàm xử lý sự kiện khi load trang
    function onPageLoading() {
      // gọi hàm load dữ liệu drink vào ô select
      loadDataDrinkToSelect();
    }

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
     // MENU SIZE COMBO
  // HÀM XỬ LÝ SỰ KIỆN KHI CHỌN MENU SIZE S CLICK
  function onBtnMenuSizeSmallClick() {
    //tạo một đối tượng combo, được tham số hóa
    var vSelectedMenuSmall = getOrder("Combo Small", "20", "2", "200g", "2", 150000);
    // gọi method hiển thị thông tin
    vSelectedMenuSmall.displayInConsoleLog();
    // đổi màu button
    changeMenuButtonsColor("Combo Small");
    // gán giá trị của combo S được chọn vào biến toàn cục để lưu tại đó
    gSelectedMenuStructure = vSelectedMenuSmall;
  }
  // HÀM XỬ LÝ SỰ KIỆN KHI CHỌN MENU SIZE M CLICK
  function onBtnMenuSizeMediumClick() {
    //tạo một đối tượng combo, được tham số hóa
    var vSelectedMenuMedium = getOrder("Combo Medium", "25", "4", "300g", "3", 200000);
    // gọi method hiển thị thông tin
    vSelectedMenuMedium.displayInConsoleLog();
    // đổi màu button
    changeMenuButtonsColor("Combo Medium");
    // gán giá trị của combo M được chọn vào biến toàn cục để lưu tại đó
    gSelectedMenuStructure = vSelectedMenuMedium;
  }
  // HÀM XỬ LÝ SỰ KIỆN KHI CHỌN MENU SIZE L CLICK
  function onBtnMenuSizeLargeClick() {
    //tạo một đối tượng combo, được tham số hóa
    var vSelectedMenuLarge = getOrder("Combo Large", "30", "8", "500g", "4", 250000);
    // gọi method hiển thị thông tin
    vSelectedMenuLarge.displayInConsoleLog();
    // đổi màu button
    changeMenuButtonsColor("Combo Large");
    // gán giá trị của combo L được chọn vào biến toàn cục để lưu tại đó
    gSelectedMenuStructure = vSelectedMenuLarge;
  };

    // HÀM XỬ LÝ SỰ KIỆN KHI ẤN NÚT KIỂM TRA ĐƠN
  function onBtnKiemTraDonClick() {
    // B1: Đọc dữ liệu
    readDataUser(gUser);
    // B2: Kiểm tra dữ liệu
    var vDuLieuHopLe = validateDataInput(gUser);
    if (vDuLieuHopLe) {
      // B3: hàm xử lý voucher(call Api)
      if(gUser.maVoucher != ""){
        xuLyDuLieuVoucher(gUser, gSelectedMenuStructure, gGiamGia);
      }
      else {
        gGiamGia.phanTramGiamGia = 0;
        gGiamGia.price = gSelectedMenuStructure.giaTien;
      }
      
      // B4: Hiển thị thông tin đơn hàng
      hienThiThongTinDonHang(gUser, gSelectedMenuStructure, gSelectedPizzaType, gGiamGia);
    }
  };

  //HÀM XỬ LÝ SỰ KIỆN KHI ẤN NÚT GỬI ĐƠN
  function onBtnGuiDonClick() {
    // B1: thu thập dữ liệu trên form
    console.log(gDonHangObject);
    // B2: kiểm tra (ko có);

    //Bước 3: Call API 
    var vXmlHttpCreateOrder = new XMLHttpRequest();
    callApiCreatOrder(gDonHangObject, vXmlHttpCreateOrder);
    vXmlHttpCreateOrder.onreadystatechange =  function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
                    //console.log( vXmlHttpCreateOrder.responseText);
                    showOrderId(vXmlHttpCreateOrder);
                }
            }
           
  }

   // Hàm xử lý sự kiện khi ấn nút ORDER DETAIL hiện ra trang mới
   function onBtnOrderDetailClick(paramOrderDetail) {
    "use strict";
       var vButtonOrderDetail = document.getElementById("order-detail");
       var vId = vButtonOrderDetail.dataset.id;
       var vOrderId = vButtonOrderDetail.dataset.orderid;

       // gọi form orderDetail 
       const vORDER_DETAIL_FORM_URL = "Order Detail Click.html";
       var vUrlSiteToOpen = vORDER_DETAIL_FORM_URL + "?id=" + vId + "&orderId=" + vOrderId;
       window.location.href = vUrlSiteToOpen;
    }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
   //Hàm get Order (chọn combo menu)
  //Hàm trả lại một đối tượng Order (chọn combo menu) được tham số hóa
  function getOrder(paramCombo, paramDuongKinh, paramSuonNuong, paramSalad, paramNuocNgot, paramPrice) {
    var vSelectedMenu = {  //Đối tượng: combo menu được chọn
      comboMenu: paramCombo, //combo = menu S/M/L
      duongKinh: paramDuongKinh,
      suonNuong: paramSuonNuong, 
      salad: paramSalad,
      nuocNgot: paramNuocNgot, 
      giaTien: paramPrice,
      
      // method display combo order - phương thức hiện thi menu combo được chọn
      displayInConsoleLog() {
        console.log("%c COMBO SELECTED - menu combo được chọn..........", "color:red");
        console.log(this.comboMenu);  //this = "đối tượng này" 
        console.log("Đường kính: " + this.duongKinh);
        console.log("Sườn nướng: " + this.suonNuong);
        console.log("Salad: " + this.salad);
        console.log("Nước ngọt: " + this.nuocNgot);
        console.log("Giá tiền: " + this.giaTien  + "VND " );
      }
    }
    return vSelectedMenu;  //trả lại đối tượng, có đủ dữ liệu (attribute) và các methods (phương thức)
  };

  // TYPE PIZZA
  // Hàm xử lý sự kiện khi ấn nút chọn pizza Hawai
  function onBtnPizzaHawaiClick() {
    "use strict"; 
      gSelectedPizzaType  = "Hawai"; 
      console.log("Loại Pizza " + gSelectedPizzaType); 
      //set trạng thái của nut - set the buttons style
      changeTypeButtonsColor(gSelectedPizzaType);
  }
  // Hàm xử lý sự kiện khi ấn nút chọn pizza Hải sản
  function onBtnPizzaHaiSanClick() {
    "use strict";
      gSelectedPizzaType  = "Hải Sản"; 
      console.log("Loại Pizza " + gSelectedPizzaType); 
      //set trạng thái của nut - set the buttons style
      changeTypeButtonsColor(gSelectedPizzaType);
  }
  // Hàm xử lý sự kiện khi ấn nút chọn pizza Thịt hun khói
  function onBtnPizzaThitHunKhoiClick() {
    "use strict";
      gSelectedPizzaType  = "Thịt Hun Khói"; 
      console.log("Loại Pizza " + gSelectedPizzaType); 
      //set trạng thái của nut - set the buttons style
      changeTypeButtonsColor(gSelectedPizzaType);
  }

  // HÀM ĐỔI MÀU BUTTON (CHỌN) ĐỂ PHÂN BIỆT COMBO ĐƯỢC CHỌN VỚI CÁC COMBO KHÁC
  // input: PARAMCOMBO có thể là S/M/L
  // hoạt động: tùy input sẽ làm nổi một nút ("btn-warning"), và chuyển hai nút còn lại bình thường ("btn-success")
  function  changeMenuButtonsColor(paramCombo) {
    "use strict"
    var vBtnSmall = document.getElementById("btn-combo-small");  // truy vấn nút combo small (chọn)
    var vBtnMedium = document.getElementById("btn-combo-medium"); //truy vấn nút combo medium (chọn) 
    var vBtnLarge = document.getElementById("btn-combo-large"); //truy vấn nút combo large (chọn) 

    if (paramCombo === "Combo Small") {  //nếu chọn Small thì thay màu nút Small bằng màu cam (btn-warning), hai nút kia xanh (btn-success)
      /* code đổi màu 3 nút, khi gói Small được chọn */
      vBtnSmall.className = "btn btn-warning";
      vBtnMedium.className = "btn btn-success";
      vBtnLarge.className = "btn btn-success";
    }
    else if (paramCombo === "Combo Medium") {  //nếu chọn Medium thì thay màu nút Medium bằng màu cam (btn-warning), hai nút kia xanh (btn-success)
       /* code đổi màu 3 nút, khi gói Medium được chọn */
      vBtnSmall.className = "btn btn-success";
      vBtnMedium.className = "btn btn-warning";
      vBtnLarge.className = "btn btn-success";
    }
    else if (paramCombo === "Combo Large") { //nếu chọn Large thì thay màu nút Large bàng màu cam, hai nút kia xanh
      /* code đổi màu 3 nút, khi gói Large được chọn */
      vBtnSmall.className = "btn btn-success";
      vBtnMedium.className = "btn btn-success";
      vBtnLarge.className = "btn btn-warning";
    }
  }

  // HÀM ĐỔI MÀU NÚT BUTTON (CHỌN) ĐỂ PHÂN BIỆT LOAI PIZZA ĐƯỢC CHỌN
  function changeTypeButtonsColor(paramTypePizza) {
    "use strict";
    var vBtnHawai = document.getElementById("btn-pizza-hawai");
    var vBtnHaiSan = document.getElementById("btn-pizza-hai-san");
    var vBtnThitHunKhoi = document.getElementById("btn-pizza-thit-hun-khoi");

    if (paramTypePizza === "Hawai") {
      vBtnHawai.className = "btn btn-warning w-100";
      vBtnHaiSan.className = "btn btn-success w-100";
      vBtnThitHunKhoi.className = "btn btn-success w-100";
    }
    if (paramTypePizza === "Hải Sản") {
      vBtnHawai.className = "btn btn-success w-100";
      vBtnHaiSan.className = "btn btn-warning w-100";
      vBtnThitHunKhoi.className = "btn btn-success w-100";
    }
    if (paramTypePizza === "Thịt Hun Khói") {
      vBtnHawai.className = "btn btn-success w-100";
      vBtnHaiSan.className = "btn btn-success w-100";
      vBtnThitHunKhoi.className = "btn btn-warning w-100";
    }
  };

  // HÀM LOAD DỮ LIỆU DRINK VÀO Ô SELECT
  function loadDataDrinkToSelect() {
    "use strict";
        const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/drinks";
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET",vBASE_URL, true);
        vXhttp.send();
        vXhttp.onreadystatechange =  function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // đổi JSON sang object
                    var JSONDrinkObject = JSON.parse(vXhttp.responseText);
                    // đổ dữ liệu vào ô select
                    var vSelectDrink = document.getElementById("select-drink");
                    for (var i = 0; i < JSONDrinkObject.length; i++) {
                      var vSelectDrinkOption = document.createElement("option");
                      // gán dữ liệu vào ô select
                      vSelectDrinkOption.value = JSONDrinkObject[i].maNuocUong;
                      vSelectDrinkOption.text = JSONDrinkObject[i].tenNuocUong;

                      vSelectDrink.appendChild(vSelectDrinkOption);
                    }
                }
            }        
  };

   // HÀM ĐỌC DỮ LIỆU User
   function readDataUser(paramUser) {
    "use strict";
      var vInputHoTen = document.getElementById("inp-fullname");
      var vInputEmail = document.getElementById("inp-email");
      var vInputSoDienThoai = document.getElementById("inp-dien-thoai");
      var vInputDiaChi = document.getElementById("inp-dia-chi");
      var vInputLoiNhan = document.getElementById("inp-message");
      var vInputMaVoucher = document.getElementById("inp-voucher");
      var vSelectDrink = document.getElementById("select-drink");
      // Đọc giá trị và ghi vào đối tượng
      paramUser.hoTen = vInputHoTen.value.trim();
      paramUser.email = vInputEmail.value.trim();
      paramUser.soDienThoai = vInputSoDienThoai.value.trim();
      paramUser.diaChi = vInputDiaChi.value.trim();
      paramUser.loiNhan = vInputLoiNhan.value;
      paramUser.maVoucher = vInputMaVoucher.value.trim();
      paramUser.comboDuocChon = gSelectedMenuStructure;
      paramUser.loaiPizzaDuocChon = gSelectedPizzaType;
      paramUser.loaiDoUongDuocChon = vSelectDrink.value;
  };

   // Hàm kiểm tra dữ liệu User nhập vào
  function validateDataInput(paramUserDataInput) {
    "use strict";
      if ( paramUserDataInput.comboDuocChon.comboMenu === "") {
        alert("Bạn chưa chọn kích cỡ Combo");
        return false;
      }
      if ( paramUserDataInput.loaiPizzaDuocChon === "...") {
        alert("Bạn chưa chọn loại Pizza yêu thích");
        return false;
      }
      if ( paramUserDataInput.loaiDoUongDuocChon === "0") {
        alert("Bạn chưa chọn loại đồ uống");
        return false;
      }
      if (paramUserDataInput.hoTen === "") {
        alert("Bạn cần nhập đẩy đủ Họ và Tên");
        return false;
      }
      var vCheckEmail = kiemTraEmail(paramUserDataInput.email); // Gọi hàm kiểm tra email có hợp lệ hay không
          if(vCheckEmail == false){
            return false;
          }
      if (paramUserDataInput.soDienThoai ==="") {
        alert("Số điện thoại không được bỏ trống");
        return false;
      } 

      if (isNaN(paramUserDataInput.soDienThoai)) {
        alert("Số điện thoại phải là dạng số");
        return false;
      } 
      if (paramUserDataInput.diaChi === "") {
        alert("Địa chỉ không được bỏ trống");
        return false;
      }

      return true;
  };
  function kiemTraEmail(paramEmail){
    var vEmail = paramEmail.trim(); // chuẩn hoá dữ liệu ở đầu xâu và cuối xâu
    // Kiểm tra email có bị rỗng hay ko?
    if(vEmail == ""){
      alert("Email chưa được nhập");
      return false;
    }
    // Kiểm tra email có chứa ký tự @ hay không?
    if(vEmail.includes('@') == false){
      alert("Email không chứa ký tự @");
      return false;
    } else {
      var vPosACong = vEmail.indexOf("@");// Hàm tìm kiếm vị trí của ký tự @ trong email nếu email có chứa @
      var vLengthEmail = vEmail.length; // Xác định chiều dài của email
      if(vLengthEmail < 3){ // chiều dài của email nhỏ hơn 3 sẽ ko hợp lệ
        alert("Chiều dài của email cần lơn hơn 3");
        vResultEmail = false;
      } else {
        if( (vPosACong == 0) || (vPosACong == vLengthEmail-1)){
          alert("Ký tự @ cần nằm ở giữa");
          return false;
        }
      }    
    }
    return true;
  };

   // HÀM XỬ LÝ DỮ LIỆU VOUCHER
  function xuLyDuLieuVoucher(paramUser, paramSelectedMenuStructure, paramGiamGia) {
     // khai báo gửi thông tin lên sever
     var vXmlHttp = new XMLHttpRequest();
    vXmlHttp.open( "GET", "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/" + paramUser.maVoucher, false);
    vXmlHttp.send();
    if(vXmlHttp.status == gREQUEST_STATUS_OK) { // restFullAPI successful
        // nhận lại response dạng JSON ở vXmlHttp.responseText và chuyển thành object
        console.log(vXmlHttp.responseText); 
        var vJSONVoucherObject = JSON.parse(vXmlHttp.responseText);
        
         //gán giá trị voucher mới nhận từ sever vào biến gGiamGia       
         paramGiamGia.maVoucher = vJSONVoucherObject.maVoucher;
         paramGiamGia.phanTramGiamGia = parseInt(vJSONVoucherObject.phanTramGiamGia);
         paramGiamGia.price = paramSelectedMenuStructure.giaTien - (paramSelectedMenuStructure.giaTien * (vJSONVoucherObject.phanTramGiamGia * 0.01))
    } 
    else {
        // không nhận lại được data do vấn đề gì đó: khả năng mã voucher ko dúng
        console.log("Không tìm thấy voucher " + vXmlHttp.responseText);
        paramGiamGia.maVoucher = "voucher không tồn tại";
        paramGiamGia.phanTramGiamGia = 0;
        paramGiamGia.price = paramSelectedMenuStructure.giaTien;

        return paramGiamGia;
    }
  };

  // HÀM HIỂN THỊ 
  function hienThiThongTinDonHang(paramUser, paramSelectedMenuStructure, paramSelectedPizzaType, paramGiamGia){
    var vDivContainer = document.getElementById("div-container-order");
    var vDivOrderInfo = document.getElementById("div-order-infor");
    var vDivOrderMenu = document.getElementById("div-order-menu");
    var vDivOrderType = document.getElementById("div-order-type");

    var vSelectDrink = document.getElementById("select-drink") // hiển thị thêm  loại đồ uống

    vDivContainer.style.display = "block";

    vDivOrderInfo.innerHTML =
          "Họ và Tên: " + paramUser.hoTen + "<br>" +
          "Email: " + paramUser.email + "<br>" +
          "Số điện thoại: " + paramUser.soDienThoai + "<br>" +
          "Địa chỉ: " + paramUser.diaChi + "<br>" +
          "Lời nhắn: " + paramUser.loiNhan + "<br>";

    vDivOrderMenu.innerHTML =
          "Menu name: " + paramSelectedMenuStructure.comboMenu + "<br>" +
          "Đường kính Pizza: " + paramSelectedMenuStructure.duongKinh + "<br>" +
          "Sườn nướng: " + paramSelectedMenuStructure.suonNuong + "<br>" +
          "Nước ngọt: " + paramSelectedMenuStructure.nuocNgot + "<br>" +                
          "Salad: " + paramSelectedMenuStructure.salad  + "<br>";

    vDivOrderType.innerHTML =
          "Loại Pizza: " + paramSelectedPizzaType + "<br>" +
          "Loại nước uống: " + vSelectDrink.value + "<br>" +
          "Mã giãm giá: " + paramGiamGia.maVoucher + "<br>" +
          "Giá tiền: " + paramSelectedMenuStructure.giaTien + "<br>" +        
          "Discount % : " + paramGiamGia.phanTramGiamGia + "%" + "<br>" +
          "Số tiền thanh toán: " + paramGiamGia.price + "VNĐ";  

     // gán vào biến toàn cục thông tin order

    gDonHangObject.kichCo = paramSelectedMenuStructure.comboMenu;
    gDonHangObject.duongKinh = paramSelectedMenuStructure.duongKinh;
    gDonHangObject.suon = paramSelectedMenuStructure.suonNuong;
    gDonHangObject.salad = paramSelectedMenuStructure.salad;
    gDonHangObject.loaiPizza = paramSelectedPizzaType;
    gDonHangObject.idVourcher = paramGiamGia.maVoucher;
    gDonHangObject.idLoaiNuocUong = vSelectDrink.options[vSelectDrink.selectedIndex.value];
    gDonHangObject.idLoaiNuocUong = vSelectDrink.value;
    gDonHangObject.soLuongNuoc = paramSelectedMenuStructure.nuocNgot;
    gDonHangObject.hoTen = paramUser.hoTen;
    gDonHangObject.thanhTien = paramGiamGia.price;
    gDonHangObject.email = paramUser.email;
    gDonHangObject.soDienThoai = paramUser.soDienThoai;
    gDonHangObject.diaChi = paramUser.diaChi;
    gDonHangObject.loiNhan = paramUser.loiNhan;
  }

  // Hàm gọi Api để tạo đơn hàng
  function callApiCreatOrder(paramDonHangObject, paramXmlHttpCreateOrder) {
    const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
    paramXmlHttpCreateOrder.open("POST", vBASE_URL, true);
    paramXmlHttpCreateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
    paramXmlHttpCreateOrder.send(JSON.stringify(paramDonHangObject));
  }
   // Show dữ liệu Order
   function showOrderId(vXmlHttpCreatOrder, paramOrderDetail) {
    // Chuyển Object sang JSON
    var vResponseCreatOrder = JSON.parse(vXmlHttpCreatOrder.responseText);

    var vFormOrderID = document.getElementById("div-container-orderid");
    var vInpOrderID = document.getElementById("inp-orderid");
    var vContainer = document.getElementById("div-container-order");

    vFormOrderID.style.display = "block";
    vContainer.style.display = "none";

    // tạo biến để chứa id và orderid của object
    var vId = vResponseCreatOrder.id;
    var vOrderId = vResponseCreatOrder.orderId;
    // ghi được  orderId nhận về vào Dataset của nút Show Order Data In New Form
    var vButtonOrderDetail = document.getElementById("order-detail");
    vButtonOrderDetail.setAttribute("data-id", vId);
    vButtonOrderDetail.setAttribute("data-orderId", vOrderId);
   }

  </script>
</body>

</html>